// src/index.tsx
import { jsx as jsx8 } from "react/jsx-runtime";
import { CancelIcon, ChevronDownIcon, ChevronUpIcon, DuplicateRowIcon, GripperDotsVerticalIcon, LockIcon, UnlockIcon } from "@fluentui/react-icons-mdl2";
import { getCompatContextProvider } from "react-querybuilder";

// src/FluentActionElement.tsx
import { jsx } from "react/jsx-runtime";
import { Button } from "@fluentui/react-components";
function _createForOfIteratorHelper(r, e) {
  var t = "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"];
  if (!t) {
    if (Array.isArray(r) || (t = _unsupportedIterableToArray(r)) || e && r && "number" == typeof r.length) {
      t && (r = t);
      var _n = 0, F = function F2() {
      };
      return { s: F, n: function n() {
        return _n >= r.length ? { done: true } : { done: false, value: r[_n++] };
      }, e: function e2(r2) {
        throw r2;
      }, f: F };
    }
    throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }
  var o, a = true, u = false;
  return { s: function s() {
    t = t.call(r);
  }, n: function n() {
    var r2 = t.next();
    return a = r2.done, r2;
  }, e: function e2(r2) {
    u = true, o = r2;
  }, f: function f() {
    try {
      a || null == t["return"] || t["return"]();
    } finally {
      if (u) throw o;
    }
  } };
}
function _unsupportedIterableToArray(r, a) {
  if (r) {
    if ("string" == typeof r) return _arrayLikeToArray(r, a);
    var t = {}.toString.call(r).slice(8, -1);
    return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0;
  }
}
function _arrayLikeToArray(r, a) {
  (null == a || a > r.length) && (a = r.length);
  for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e];
  return n;
}
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = function __defNormalProp2(obj, key, value) {
  return key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
};
var __spreadValues = function __spreadValues2(a, b) {
  for (var prop in b || (b = {})) if (__hasOwnProp.call(b, prop)) __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols) {
    var _iterator = _createForOfIteratorHelper(__getOwnPropSymbols(b)), _step;
    try {
      for (_iterator.s(); !(_step = _iterator.n()).done; ) {
        var prop = _step.value;
        if (__propIsEnum.call(b, prop)) __defNormalProp(a, prop, b[prop]);
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }
  }
  return a;
};
var __spreadProps = function __spreadProps2(a, b) {
  return __defProps(a, __getOwnPropDescs(b));
};
var __objRest = function __objRest2(source, exclude) {
  var target = {};
  for (var prop in source) if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0) target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols) {
    var _iterator2 = _createForOfIteratorHelper(__getOwnPropSymbols(source)), _step2;
    try {
      for (_iterator2.s(); !(_step2 = _iterator2.n()).done; ) {
        var prop = _step2.value;
        if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop)) target[prop] = source[prop];
      }
    } catch (err) {
      _iterator2.e(err);
    } finally {
      _iterator2.f();
    }
  }
  return target;
};
var FluentActionElement = function FluentActionElement2(_a) {
  var _b = _a, className = _b.className, handleOnClick = _b.handleOnClick, label = _b.label, title = _b.title, disabled = _b.disabled, disabledTranslation = _b.disabledTranslation, testID = _b.testID, _rules = _b.rules, _rg = _b.ruleOrGroup, _path = _b.path, _level = _b.level, _context = _b.context, _validation = _b.validation, _schema = _b.schema, otherProps = __objRest(_b, ["className", "handleOnClick", "label", "title", "disabled", "disabledTranslation", "testID", "rules", "ruleOrGroup", "path", "level", "context", "validation", "schema"]);
  return /* @__PURE__ */ jsx(Button, __spreadProps(__spreadValues({}, otherProps), { "data-testid": testID, type: "button", className, title: disabledTranslation && disabled ? disabledTranslation.title : title, onClick: function onClick(e) {
    return handleOnClick(e);
  }, disabled: disabled && !disabledTranslation, children: disabledTranslation && disabled ? disabledTranslation.label : label }));
};

// src/FluentDragHandle.tsx
import { jsx as jsx2 } from "react/jsx-runtime";
import { Text } from "@fluentui/react-components";
import { forwardRef } from "react";
function _createForOfIteratorHelper2(r, e) {
  var t = "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"];
  if (!t) {
    if (Array.isArray(r) || (t = _unsupportedIterableToArray2(r)) || e && r && "number" == typeof r.length) {
      t && (r = t);
      var _n = 0, F = function F2() {
      };
      return { s: F, n: function n() {
        return _n >= r.length ? { done: true } : { done: false, value: r[_n++] };
      }, e: function e2(r2) {
        throw r2;
      }, f: F };
    }
    throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }
  var o, a = true, u = false;
  return { s: function s() {
    t = t.call(r);
  }, n: function n() {
    var r2 = t.next();
    return a = r2.done, r2;
  }, e: function e2(r2) {
    u = true, o = r2;
  }, f: function f() {
    try {
      a || null == t["return"] || t["return"]();
    } finally {
      if (u) throw o;
    }
  } };
}
function _unsupportedIterableToArray2(r, a) {
  if (r) {
    if ("string" == typeof r) return _arrayLikeToArray2(r, a);
    var t = {}.toString.call(r).slice(8, -1);
    return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray2(r, a) : void 0;
  }
}
function _arrayLikeToArray2(r, a) {
  (null == a || a > r.length) && (a = r.length);
  for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e];
  return n;
}
var __defProp2 = Object.defineProperty;
var __defProps2 = Object.defineProperties;
var __getOwnPropDescs2 = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols2 = Object.getOwnPropertySymbols;
var __hasOwnProp2 = Object.prototype.hasOwnProperty;
var __propIsEnum2 = Object.prototype.propertyIsEnumerable;
var __defNormalProp3 = function __defNormalProp4(obj, key, value) {
  return key in obj ? __defProp2(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
};
var __spreadValues3 = function __spreadValues4(a, b) {
  for (var prop in b || (b = {})) if (__hasOwnProp2.call(b, prop)) __defNormalProp3(a, prop, b[prop]);
  if (__getOwnPropSymbols2) {
    var _iterator = _createForOfIteratorHelper2(__getOwnPropSymbols2(b)), _step;
    try {
      for (_iterator.s(); !(_step = _iterator.n()).done; ) {
        var prop = _step.value;
        if (__propIsEnum2.call(b, prop)) __defNormalProp3(a, prop, b[prop]);
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }
  }
  return a;
};
var __spreadProps3 = function __spreadProps4(a, b) {
  return __defProps2(a, __getOwnPropDescs2(b));
};
var __objRest3 = function __objRest4(source, exclude) {
  var target = {};
  for (var prop in source) if (__hasOwnProp2.call(source, prop) && exclude.indexOf(prop) < 0) target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols2) {
    var _iterator2 = _createForOfIteratorHelper2(__getOwnPropSymbols2(source)), _step2;
    try {
      for (_iterator2.s(); !(_step2 = _iterator2.n()).done; ) {
        var prop = _step2.value;
        if (exclude.indexOf(prop) < 0 && __propIsEnum2.call(source, prop)) target[prop] = source[prop];
      }
    } catch (err) {
      _iterator2.e(err);
    } finally {
      _iterator2.f();
    }
  }
  return target;
};
var FluentDragHandle = /* @__PURE__ */ forwardRef(function(_a, dragRef) {
  var _b = _a, className = _b.className, title = _b.title, label = _b.label, testID = _b.testID, _schema = _b.schema, _ruleOrGroup = _b.ruleOrGroup, otherProps = __objRest3(_b, ["className", "title", "label", "testID", "schema", "ruleOrGroup"]);
  return /* @__PURE__ */ jsx2(Text, __spreadProps3(__spreadValues3({ "data-testid": testID, className, title }, otherProps), { ref: dragRef, children: label }));
});

// src/FluentNotToggle.tsx
import { jsx as jsx3 } from "react/jsx-runtime";
import { Switch } from "@fluentui/react-components";
function _createForOfIteratorHelper3(r, e) {
  var t = "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"];
  if (!t) {
    if (Array.isArray(r) || (t = _unsupportedIterableToArray3(r)) || e && r && "number" == typeof r.length) {
      t && (r = t);
      var _n = 0, F = function F2() {
      };
      return { s: F, n: function n() {
        return _n >= r.length ? { done: true } : { done: false, value: r[_n++] };
      }, e: function e2(r2) {
        throw r2;
      }, f: F };
    }
    throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }
  var o, a = true, u = false;
  return { s: function s() {
    t = t.call(r);
  }, n: function n() {
    var r2 = t.next();
    return a = r2.done, r2;
  }, e: function e2(r2) {
    u = true, o = r2;
  }, f: function f() {
    try {
      a || null == t["return"] || t["return"]();
    } finally {
      if (u) throw o;
    }
  } };
}
function _unsupportedIterableToArray3(r, a) {
  if (r) {
    if ("string" == typeof r) return _arrayLikeToArray3(r, a);
    var t = {}.toString.call(r).slice(8, -1);
    return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray3(r, a) : void 0;
  }
}
function _arrayLikeToArray3(r, a) {
  (null == a || a > r.length) && (a = r.length);
  for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e];
  return n;
}
var __defProp3 = Object.defineProperty;
var __defProps3 = Object.defineProperties;
var __getOwnPropDescs3 = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols3 = Object.getOwnPropertySymbols;
var __hasOwnProp3 = Object.prototype.hasOwnProperty;
var __propIsEnum3 = Object.prototype.propertyIsEnumerable;
var __defNormalProp5 = function __defNormalProp6(obj, key, value) {
  return key in obj ? __defProp3(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
};
var __spreadValues5 = function __spreadValues6(a, b) {
  for (var prop in b || (b = {})) if (__hasOwnProp3.call(b, prop)) __defNormalProp5(a, prop, b[prop]);
  if (__getOwnPropSymbols3) {
    var _iterator = _createForOfIteratorHelper3(__getOwnPropSymbols3(b)), _step;
    try {
      for (_iterator.s(); !(_step = _iterator.n()).done; ) {
        var prop = _step.value;
        if (__propIsEnum3.call(b, prop)) __defNormalProp5(a, prop, b[prop]);
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }
  }
  return a;
};
var __spreadProps5 = function __spreadProps6(a, b) {
  return __defProps3(a, __getOwnPropDescs3(b));
};
var __objRest5 = function __objRest6(source, exclude) {
  var target = {};
  for (var prop in source) if (__hasOwnProp3.call(source, prop) && exclude.indexOf(prop) < 0) target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols3) {
    var _iterator2 = _createForOfIteratorHelper3(__getOwnPropSymbols3(source)), _step2;
    try {
      for (_iterator2.s(); !(_step2 = _iterator2.n()).done; ) {
        var prop = _step2.value;
        if (exclude.indexOf(prop) < 0 && __propIsEnum3.call(source, prop)) target[prop] = source[prop];
      }
    } catch (err) {
      _iterator2.e(err);
    } finally {
      _iterator2.f();
    }
  }
  return target;
};
var FluentNotToggle = function FluentNotToggle2(_a) {
  var _b = _a, className = _b.className, handleOnChange = _b.handleOnChange, label = _b.label, checked = _b.checked, title = _b.title, disabled = _b.disabled, testID = _b.testID, _path = _b.path, _level = _b.level, _context = _b.context, _validation = _b.validation, _schema = _b.schema, _ruleGroup = _b.ruleGroup, otherProps = __objRest5(_b, ["className", "handleOnChange", "label", "checked", "title", "disabled", "testID", "path", "level", "context", "validation", "schema", "ruleGroup"]);
  return /* @__PURE__ */ jsx3(Switch, __spreadProps5(__spreadValues5({}, otherProps), { "data-testid": testID, label: "".concat(label), className, title, disabled, checked, onChange: function onChange(e) {
    return handleOnChange(e.target.checked);
  } }));
};

// src/FluentShiftActions.tsx
import { jsx as jsx4, jsxs } from "react/jsx-runtime";
import { Button as Button2 } from "@fluentui/react-components";
var FluentShiftActions = function FluentShiftActions2(_ref) {
  var shiftUp = _ref.shiftUp, shiftDown = _ref.shiftDown, shiftUpDisabled = _ref.shiftUpDisabled, shiftDownDisabled = _ref.shiftDownDisabled, disabled = _ref.disabled, className = _ref.className, labels = _ref.labels, titles = _ref.titles, testID = _ref.testID;
  return /* @__PURE__ */ jsxs("div", { "data-testid": testID, className, children: [/* @__PURE__ */ jsx4(Button2, { type: "button", disabled: disabled || shiftUpDisabled, onClick: shiftUp, title: titles == null ? void 0 : titles.shiftUp, children: labels == null ? void 0 : labels.shiftUp }), /* @__PURE__ */ jsx4(Button2, { type: "button", disabled: disabled || shiftDownDisabled, onClick: shiftDown, title: titles == null ? void 0 : titles.shiftDown, children: labels == null ? void 0 : labels.shiftDown })] });
};

// src/FluentValueEditor.tsx
import { jsx as jsx5, jsxs as jsxs2 } from "react/jsx-runtime";
import { Checkbox, Input, Radio, RadioGroup, Switch as Switch2, Textarea } from "@fluentui/react-components";
import { useValueEditor, ValueEditor } from "react-querybuilder";
function _createForOfIteratorHelper4(r, e) {
  var t = "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"];
  if (!t) {
    if (Array.isArray(r) || (t = _unsupportedIterableToArray4(r)) || e && r && "number" == typeof r.length) {
      t && (r = t);
      var _n = 0, F = function F2() {
      };
      return { s: F, n: function n() {
        return _n >= r.length ? { done: true } : { done: false, value: r[_n++] };
      }, e: function e2(r2) {
        throw r2;
      }, f: F };
    }
    throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }
  var o, a = true, u = false;
  return { s: function s() {
    t = t.call(r);
  }, n: function n() {
    var r2 = t.next();
    return a = r2.done, r2;
  }, e: function e2(r2) {
    u = true, o = r2;
  }, f: function f() {
    try {
      a || null == t["return"] || t["return"]();
    } finally {
      if (u) throw o;
    }
  } };
}
function _unsupportedIterableToArray4(r, a) {
  if (r) {
    if ("string" == typeof r) return _arrayLikeToArray4(r, a);
    var t = {}.toString.call(r).slice(8, -1);
    return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray4(r, a) : void 0;
  }
}
function _arrayLikeToArray4(r, a) {
  (null == a || a > r.length) && (a = r.length);
  for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e];
  return n;
}
var __defProp4 = Object.defineProperty;
var __defProps4 = Object.defineProperties;
var __getOwnPropDescs4 = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols4 = Object.getOwnPropertySymbols;
var __hasOwnProp4 = Object.prototype.hasOwnProperty;
var __propIsEnum4 = Object.prototype.propertyIsEnumerable;
var __defNormalProp7 = function __defNormalProp8(obj, key, value) {
  return key in obj ? __defProp4(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
};
var __spreadValues7 = function __spreadValues8(a, b) {
  for (var prop in b || (b = {})) if (__hasOwnProp4.call(b, prop)) __defNormalProp7(a, prop, b[prop]);
  if (__getOwnPropSymbols4) {
    var _iterator = _createForOfIteratorHelper4(__getOwnPropSymbols4(b)), _step;
    try {
      for (_iterator.s(); !(_step = _iterator.n()).done; ) {
        var prop = _step.value;
        if (__propIsEnum4.call(b, prop)) __defNormalProp7(a, prop, b[prop]);
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }
  }
  return a;
};
var __spreadProps7 = function __spreadProps8(a, b) {
  return __defProps4(a, __getOwnPropDescs4(b));
};
var __objRest7 = function __objRest8(source, exclude) {
  var target = {};
  for (var prop in source) if (__hasOwnProp4.call(source, prop) && exclude.indexOf(prop) < 0) target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols4) {
    var _iterator2 = _createForOfIteratorHelper4(__getOwnPropSymbols4(source)), _step2;
    try {
      for (_iterator2.s(); !(_step2 = _iterator2.n()).done; ) {
        var prop = _step2.value;
        if (exclude.indexOf(prop) < 0 && __propIsEnum4.call(source, prop)) target[prop] = source[prop];
      }
    } catch (err) {
      _iterator2.e(err);
    } finally {
      _iterator2.f();
    }
  }
  return target;
};
var FluentValueEditor = function FluentValueEditor2(allProps) {
  var _b;
  var _a = allProps, fieldData = _a.fieldData, operator = _a.operator, value = _a.value, handleOnChange = _a.handleOnChange, title = _a.title, className = _a.className, type = _a.type, inputType = _a.inputType, _a$values = _a.values, values = _a$values === void 0 ? [] : _a$values, _listsAsArrays = _a.listsAsArrays, separator = _a.separator, _vs = _a.valueSource, disabled = _a.disabled, testID = _a.testID, _SelectorComponent = _a.selectorComponent, _validation = _a.validation, extraProps = _a.extraProps, _parseNumbers = _a.parseNumbers, _propsForValueSelector = __objRest7(_a, ["fieldData", "operator", "value", "handleOnChange", "title", "className", "type", "inputType", "values", "listsAsArrays", "separator", "valueSource", "disabled", "testID", "selectorComponent", "validation", "extraProps", "parseNumbers"]);
  var _useValueEditor = useValueEditor(allProps), valueAsArray = _useValueEditor.valueAsArray, multiValueHandler = _useValueEditor.multiValueHandler, bigIntValueHandler = _useValueEditor.bigIntValueHandler, valueListItemClassName = _useValueEditor.valueListItemClassName, inputTypeCoerced = _useValueEditor.inputTypeCoerced;
  if (operator === "null" || operator === "notNull") {
    return null;
  }
  var placeHolderText = (_b = fieldData == null ? void 0 : fieldData.placeholder) != null ? _b : "";
  if ((operator === "between" || operator === "notBetween") && (type === "select" || type === "text")) {
    if (type === "text") {
      var editors = ["from", "to"].map(function(key, i) {
        var _a2;
        return /* @__PURE__ */ jsx5(Input, __spreadValues7({ type: inputTypeCoerced, placeholder: placeHolderText, value: (_a2 = valueAsArray[i]) != null ? _a2 : "", className: "".concat(valueListItemClassName, " input"), disabled, onChange: function onChange(e) {
          return multiValueHandler(e.target.value, i);
        } }, extraProps), key);
      });
      return /* @__PURE__ */ jsxs2("span", { "data-testid": testID, className, title, children: [editors[0], separator, editors[1]] });
    }
    return /* @__PURE__ */ jsx5(ValueEditor, __spreadProps7(__spreadValues7({}, allProps), { skipHook: true }));
  }
  switch (type) {
    case "select":
    case "multiselect":
      return /* @__PURE__ */ jsx5(ValueEditor, __spreadProps7(__spreadValues7({}, allProps), { skipHook: true }));
    case "textarea":
      return /* @__PURE__ */ jsx5(Textarea, __spreadValues7({ className, value, title, placeholder: placeHolderText, disabled, onChange: function onChange(e_2) {
        return handleOnChange(e_2.target.value);
      } }, extraProps));
    case "switch":
      return /* @__PURE__ */ jsx5(Switch2, __spreadValues7({ className, title, checked: value, disabled, onChange: function onChange(e_1) {
        return handleOnChange(e_1.target.checked);
      } }, extraProps));
    case "checkbox":
      return /* @__PURE__ */ jsx5(Checkbox, __spreadValues7({ className, title, checked: value, disabled, onChange: function onChange(e_0) {
        return handleOnChange(e_0.target.checked);
      } }, extraProps));
    case "radio":
      return /* @__PURE__ */ jsx5(RadioGroup, __spreadProps7(__spreadValues7({ className, title, value, onChange: function onChange(_e, data) {
        return handleOnChange(data.value);
      }, disabled }, extraProps), { children: values.map(function(v) {
        return /* @__PURE__ */ jsx5(Radio, { value: v.name, label: v.label }, v.name);
      }) }));
  }
  if (inputType === "bigint") {
    return /* @__PURE__ */ jsx5(Input, __spreadValues7({ "data-testid": testID, type: inputTypeCoerced, placeholder: placeHolderText, value: "".concat(value), title, className, disabled, onChange: function onChange(e_3) {
      return bigIntValueHandler(e_3.target.value);
    } }, extraProps));
  }
  return /* @__PURE__ */ jsx5(Input, __spreadValues7({ "data-testid": testID, title, className, placeholder: placeHolderText, type: inputTypeCoerced, disabled, value, onChange: function onChange(e_4) {
    return handleOnChange(e_4.target.value);
  } }, extraProps));
};

// src/FluentValueSelector.tsx
import { jsx as jsx7 } from "react/jsx-runtime";
import { Dropdown, Select } from "@fluentui/react-components";
import { toArray, toOptions, useValueSelector } from "react-querybuilder";

// src/utils.tsx
import { jsx as jsx6 } from "react/jsx-runtime";
import { Option, OptionGroup } from "@fluentui/react-components";
import { isOptionGroupArray } from "react-querybuilder";
var toDropdownOptions = function toDropdownOptions2(list) {
  return isOptionGroupArray(list) ? list.map(function(og) {
    return /* @__PURE__ */ jsx6(OptionGroup, { label: og.label, children: og.options.map(function(opt) {
      return /* @__PURE__ */ jsx6(Option, { value: opt.name, disabled: !!opt.disabled, children: opt.label }, opt.name);
    }) }, og.label);
  }) : Array.isArray(list) ? list.map(function(opt) {
    return /* @__PURE__ */ jsx6(Option, { value: opt.name, disabled: !!opt.disabled, children: opt.label }, opt.name);
  }) : (
    // istanbul ignore next
    null
  );
};

// src/FluentValueSelector.tsx
function _createForOfIteratorHelper5(r, e) {
  var t = "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"];
  if (!t) {
    if (Array.isArray(r) || (t = _unsupportedIterableToArray5(r)) || e && r && "number" == typeof r.length) {
      t && (r = t);
      var _n = 0, F = function F2() {
      };
      return { s: F, n: function n() {
        return _n >= r.length ? { done: true } : { done: false, value: r[_n++] };
      }, e: function e2(r2) {
        throw r2;
      }, f: F };
    }
    throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }
  var o, a = true, u = false;
  return { s: function s() {
    t = t.call(r);
  }, n: function n() {
    var r2 = t.next();
    return a = r2.done, r2;
  }, e: function e2(r2) {
    u = true, o = r2;
  }, f: function f() {
    try {
      a || null == t["return"] || t["return"]();
    } finally {
      if (u) throw o;
    }
  } };
}
function _unsupportedIterableToArray5(r, a) {
  if (r) {
    if ("string" == typeof r) return _arrayLikeToArray5(r, a);
    var t = {}.toString.call(r).slice(8, -1);
    return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray5(r, a) : void 0;
  }
}
function _arrayLikeToArray5(r, a) {
  (null == a || a > r.length) && (a = r.length);
  for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e];
  return n;
}
var __defProp5 = Object.defineProperty;
var __defProps5 = Object.defineProperties;
var __getOwnPropDescs5 = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols5 = Object.getOwnPropertySymbols;
var __hasOwnProp5 = Object.prototype.hasOwnProperty;
var __propIsEnum5 = Object.prototype.propertyIsEnumerable;
var __defNormalProp9 = function __defNormalProp10(obj, key, value) {
  return key in obj ? __defProp5(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
};
var __spreadValues9 = function __spreadValues10(a, b) {
  for (var prop in b || (b = {})) if (__hasOwnProp5.call(b, prop)) __defNormalProp9(a, prop, b[prop]);
  if (__getOwnPropSymbols5) {
    var _iterator = _createForOfIteratorHelper5(__getOwnPropSymbols5(b)), _step;
    try {
      for (_iterator.s(); !(_step = _iterator.n()).done; ) {
        var prop = _step.value;
        if (__propIsEnum5.call(b, prop)) __defNormalProp9(a, prop, b[prop]);
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }
  }
  return a;
};
var __spreadProps9 = function __spreadProps10(a, b) {
  return __defProps5(a, __getOwnPropDescs5(b));
};
var __objRest9 = function __objRest10(source, exclude) {
  var target = {};
  for (var prop in source) if (__hasOwnProp5.call(source, prop) && exclude.indexOf(prop) < 0) target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols5) {
    var _iterator2 = _createForOfIteratorHelper5(__getOwnPropSymbols5(source)), _step2;
    try {
      for (_iterator2.s(); !(_step2 = _iterator2.n()).done; ) {
        var prop = _step2.value;
        if (exclude.indexOf(prop) < 0 && __propIsEnum5.call(source, prop)) target[prop] = source[prop];
      }
    } catch (err) {
      _iterator2.e(err);
    } finally {
      _iterator2.f();
    }
  }
  return target;
};
var FluentValueSelector = function FluentValueSelector2(_a) {
  var _b = _a, className = _b.className, handleOnChange = _b.handleOnChange, options = _b.options, value = _b.value, title = _b.title, disabled = _b.disabled, multiple = _b.multiple, listsAsArrays = _b.listsAsArrays, testID = _b.testID, placeholder = _b.placeholder, _fieldData = _b.fieldData, _path = _b.path, _level = _b.level, _context = _b.context, _validation = _b.validation, _schema = _b.schema, _rule = _b.rule, _rules = _b.rules, otherProps = __objRest9(_b, ["className", "handleOnChange", "options", "value", "title", "disabled", "multiple", "listsAsArrays", "testID", "placeholder", "fieldData", "path", "level", "context", "validation", "schema", "rule", "rules"]);
  var _useValueSelector = useValueSelector({ handleOnChange, listsAsArrays, multiple, value }), _onChange = _useValueSelector.onChange, val = _useValueSelector.val;
  return multiple ? /* @__PURE__ */ jsx7(Dropdown, { "data-testid": testID, title, className, disabled, multiselect: true, value: toArray(val).join(", "), placeholder, selectedOptions: toArray(val), onOptionSelect: function onOptionSelect(_e, data) {
    return _onChange(data.selectedOptions);
  }, children: toDropdownOptions(options) }) : /* @__PURE__ */ jsx7(Select, __spreadProps9(__spreadValues9({}, otherProps), { "data-testid": testID, title, className, value: val, disabled, multiple: !!multiple, onChange: function onChange(_e_0, data_0) {
    return _onChange(data_0.value);
  }, children: toOptions(options) }));
};

// src/index.tsx
var fluentControlElements = { actionElement: FluentActionElement, dragHandle: FluentDragHandle, notToggle: FluentNotToggle, shiftActions: FluentShiftActions, valueEditor: FluentValueEditor, valueSelector: FluentValueSelector };
var fluentTranslations = { removeGroup: { label: /* @__PURE__ */ jsx8(CancelIcon, {}) }, removeRule: { label: /* @__PURE__ */ jsx8(CancelIcon, {}) }, cloneRule: { label: /* @__PURE__ */ jsx8(DuplicateRowIcon, {}) }, cloneRuleGroup: { label: /* @__PURE__ */ jsx8(DuplicateRowIcon, {}) }, dragHandle: { label: /* @__PURE__ */ jsx8(GripperDotsVerticalIcon, {}) }, lockGroup: { label: /* @__PURE__ */ jsx8(UnlockIcon, {}) }, lockRule: { label: /* @__PURE__ */ jsx8(UnlockIcon, {}) }, lockGroupDisabled: { label: /* @__PURE__ */ jsx8(LockIcon, {}) }, lockRuleDisabled: { label: /* @__PURE__ */ jsx8(LockIcon, {}) }, shiftActionDown: { label: /* @__PURE__ */ jsx8(ChevronDownIcon, {}) }, shiftActionUp: { label: /* @__PURE__ */ jsx8(ChevronUpIcon, {}) } };
var QueryBuilderFluent = getCompatContextProvider({ controlElements: fluentControlElements, translations: fluentTranslations });
export {
  FluentActionElement,
  FluentDragHandle,
  FluentNotToggle,
  FluentShiftActions,
  FluentValueEditor,
  FluentValueSelector,
  QueryBuilderFluent,
  fluentControlElements,
  fluentTranslations
};
//# sourceMappingURL=react-querybuilder_fluent.legacy-esm.js.map