// src/index.tsx
import { jsx as jsx8 } from "react/jsx-runtime";
import { CancelIcon, ChevronDownIcon, ChevronUpIcon, DuplicateRowIcon, GripperDotsVerticalIcon, LockIcon, UnlockIcon } from "@fluentui/react-icons-mdl2";
import { getCompatContextProvider } from "react-querybuilder";

// src/FluentActionElement.tsx
import { jsx } from "react/jsx-runtime";
import { Button } from "@fluentui/react-components";
function _typeof(o) {
  "@babel/helpers - typeof";
  return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function(o2) {
    return typeof o2;
  } : function(o2) {
    return o2 && "function" == typeof Symbol && o2.constructor === Symbol && o2 !== Symbol.prototype ? "symbol" : typeof o2;
  }, _typeof(o);
}
var _excluded = ["className", "handleOnClick", "label", "title", "disabled", "disabledTranslation", "testID", "rules", "ruleOrGroup", "path", "level", "context", "validation", "schema"];
function ownKeys(e, r) {
  var t = Object.keys(e);
  if (Object.getOwnPropertySymbols) {
    var o = Object.getOwnPropertySymbols(e);
    r && (o = o.filter(function(r2) {
      return Object.getOwnPropertyDescriptor(e, r2).enumerable;
    })), t.push.apply(t, o);
  }
  return t;
}
function _objectSpread(e) {
  for (var r = 1; r < arguments.length; r++) {
    var t = null != arguments[r] ? arguments[r] : {};
    r % 2 ? ownKeys(Object(t), true).forEach(function(r2) {
      _defineProperty(e, r2, t[r2]);
    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function(r2) {
      Object.defineProperty(e, r2, Object.getOwnPropertyDescriptor(t, r2));
    });
  }
  return e;
}
function _defineProperty(e, r, t) {
  return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: true, configurable: true, writable: true }) : e[r] = t, e;
}
function _toPropertyKey(t) {
  var i = _toPrimitive(t, "string");
  return "symbol" == _typeof(i) ? i : i + "";
}
function _toPrimitive(t, r) {
  if ("object" != _typeof(t) || !t) return t;
  var e = t[Symbol.toPrimitive];
  if (void 0 !== e) {
    var i = e.call(t, r || "default");
    if ("object" != _typeof(i)) return i;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return ("string" === r ? String : Number)(t);
}
function _objectWithoutProperties(e, t) {
  if (null == e) return {};
  var o, r, i = _objectWithoutPropertiesLoose(e, t);
  if (Object.getOwnPropertySymbols) {
    var n = Object.getOwnPropertySymbols(e);
    for (r = 0; r < n.length; r++) o = n[r], -1 === t.indexOf(o) && {}.propertyIsEnumerable.call(e, o) && (i[o] = e[o]);
  }
  return i;
}
function _objectWithoutPropertiesLoose(r, e) {
  if (null == r) return {};
  var t = {};
  for (var n in r) if ({}.hasOwnProperty.call(r, n)) {
    if (-1 !== e.indexOf(n)) continue;
    t[n] = r[n];
  }
  return t;
}
var FluentActionElement = function FluentActionElement2(_ref) {
  var className = _ref.className, handleOnClick = _ref.handleOnClick, label = _ref.label, title = _ref.title, disabled = _ref.disabled, disabledTranslation = _ref.disabledTranslation, testID = _ref.testID, _rules = _ref.rules, _rg = _ref.ruleOrGroup, _path = _ref.path, _level = _ref.level, _context = _ref.context, _validation = _ref.validation, _schema = _ref.schema, otherProps = _objectWithoutProperties(_ref, _excluded);
  return /* @__PURE__ */ jsx(Button, _objectSpread(_objectSpread({}, otherProps), {}, { "data-testid": testID, type: "button", className, title: disabledTranslation && disabled ? disabledTranslation.title : title, onClick: function onClick(e) {
    return handleOnClick(e);
  }, disabled: disabled && !disabledTranslation, children: disabledTranslation && disabled ? disabledTranslation.label : label }));
};

// src/FluentDragHandle.tsx
import { jsx as jsx2 } from "react/jsx-runtime";
import { Text } from "@fluentui/react-components";
import { forwardRef } from "react";
function _typeof2(o) {
  "@babel/helpers - typeof";
  return _typeof2 = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function(o2) {
    return typeof o2;
  } : function(o2) {
    return o2 && "function" == typeof Symbol && o2.constructor === Symbol && o2 !== Symbol.prototype ? "symbol" : typeof o2;
  }, _typeof2(o);
}
var _excluded2 = ["className", "title", "label", "testID", "schema", "ruleOrGroup"];
function ownKeys2(e, r) {
  var t = Object.keys(e);
  if (Object.getOwnPropertySymbols) {
    var o = Object.getOwnPropertySymbols(e);
    r && (o = o.filter(function(r2) {
      return Object.getOwnPropertyDescriptor(e, r2).enumerable;
    })), t.push.apply(t, o);
  }
  return t;
}
function _objectSpread2(e) {
  for (var r = 1; r < arguments.length; r++) {
    var t = null != arguments[r] ? arguments[r] : {};
    r % 2 ? ownKeys2(Object(t), true).forEach(function(r2) {
      _defineProperty2(e, r2, t[r2]);
    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys2(Object(t)).forEach(function(r2) {
      Object.defineProperty(e, r2, Object.getOwnPropertyDescriptor(t, r2));
    });
  }
  return e;
}
function _defineProperty2(e, r, t) {
  return (r = _toPropertyKey2(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: true, configurable: true, writable: true }) : e[r] = t, e;
}
function _toPropertyKey2(t) {
  var i = _toPrimitive2(t, "string");
  return "symbol" == _typeof2(i) ? i : i + "";
}
function _toPrimitive2(t, r) {
  if ("object" != _typeof2(t) || !t) return t;
  var e = t[Symbol.toPrimitive];
  if (void 0 !== e) {
    var i = e.call(t, r || "default");
    if ("object" != _typeof2(i)) return i;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return ("string" === r ? String : Number)(t);
}
function _objectWithoutProperties2(e, t) {
  if (null == e) return {};
  var o, r, i = _objectWithoutPropertiesLoose2(e, t);
  if (Object.getOwnPropertySymbols) {
    var n = Object.getOwnPropertySymbols(e);
    for (r = 0; r < n.length; r++) o = n[r], -1 === t.indexOf(o) && {}.propertyIsEnumerable.call(e, o) && (i[o] = e[o]);
  }
  return i;
}
function _objectWithoutPropertiesLoose2(r, e) {
  if (null == r) return {};
  var t = {};
  for (var n in r) if ({}.hasOwnProperty.call(r, n)) {
    if (-1 !== e.indexOf(n)) continue;
    t[n] = r[n];
  }
  return t;
}
var FluentDragHandle = /* @__PURE__ */ forwardRef(function(_ref, dragRef) {
  var className = _ref.className, title = _ref.title, label = _ref.label, testID = _ref.testID, _schema = _ref.schema, _ruleOrGroup = _ref.ruleOrGroup, otherProps = _objectWithoutProperties2(_ref, _excluded2);
  return /* @__PURE__ */ jsx2(Text, _objectSpread2(_objectSpread2({ "data-testid": testID, className, title }, otherProps), {}, { ref: dragRef, children: label }));
});

// src/FluentNotToggle.tsx
import { jsx as jsx3 } from "react/jsx-runtime";
import { Switch } from "@fluentui/react-components";
function _typeof3(o) {
  "@babel/helpers - typeof";
  return _typeof3 = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function(o2) {
    return typeof o2;
  } : function(o2) {
    return o2 && "function" == typeof Symbol && o2.constructor === Symbol && o2 !== Symbol.prototype ? "symbol" : typeof o2;
  }, _typeof3(o);
}
var _excluded3 = ["className", "handleOnChange", "label", "checked", "title", "disabled", "testID", "path", "level", "context", "validation", "schema", "ruleGroup"];
function ownKeys3(e, r) {
  var t = Object.keys(e);
  if (Object.getOwnPropertySymbols) {
    var o = Object.getOwnPropertySymbols(e);
    r && (o = o.filter(function(r2) {
      return Object.getOwnPropertyDescriptor(e, r2).enumerable;
    })), t.push.apply(t, o);
  }
  return t;
}
function _objectSpread3(e) {
  for (var r = 1; r < arguments.length; r++) {
    var t = null != arguments[r] ? arguments[r] : {};
    r % 2 ? ownKeys3(Object(t), true).forEach(function(r2) {
      _defineProperty3(e, r2, t[r2]);
    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys3(Object(t)).forEach(function(r2) {
      Object.defineProperty(e, r2, Object.getOwnPropertyDescriptor(t, r2));
    });
  }
  return e;
}
function _defineProperty3(e, r, t) {
  return (r = _toPropertyKey3(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: true, configurable: true, writable: true }) : e[r] = t, e;
}
function _toPropertyKey3(t) {
  var i = _toPrimitive3(t, "string");
  return "symbol" == _typeof3(i) ? i : i + "";
}
function _toPrimitive3(t, r) {
  if ("object" != _typeof3(t) || !t) return t;
  var e = t[Symbol.toPrimitive];
  if (void 0 !== e) {
    var i = e.call(t, r || "default");
    if ("object" != _typeof3(i)) return i;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return ("string" === r ? String : Number)(t);
}
function _objectWithoutProperties3(e, t) {
  if (null == e) return {};
  var o, r, i = _objectWithoutPropertiesLoose3(e, t);
  if (Object.getOwnPropertySymbols) {
    var n = Object.getOwnPropertySymbols(e);
    for (r = 0; r < n.length; r++) o = n[r], -1 === t.indexOf(o) && {}.propertyIsEnumerable.call(e, o) && (i[o] = e[o]);
  }
  return i;
}
function _objectWithoutPropertiesLoose3(r, e) {
  if (null == r) return {};
  var t = {};
  for (var n in r) if ({}.hasOwnProperty.call(r, n)) {
    if (-1 !== e.indexOf(n)) continue;
    t[n] = r[n];
  }
  return t;
}
var FluentNotToggle = function FluentNotToggle2(_ref) {
  var className = _ref.className, handleOnChange = _ref.handleOnChange, label = _ref.label, checked = _ref.checked, title = _ref.title, disabled = _ref.disabled, testID = _ref.testID, _path = _ref.path, _level = _ref.level, _context = _ref.context, _validation = _ref.validation, _schema = _ref.schema, _ruleGroup = _ref.ruleGroup, otherProps = _objectWithoutProperties3(_ref, _excluded3);
  return /* @__PURE__ */ jsx3(Switch, _objectSpread3(_objectSpread3({}, otherProps), {}, { "data-testid": testID, label: "".concat(label), className, title, disabled, checked, onChange: function onChange(e) {
    return handleOnChange(e.target.checked);
  } }));
};

// src/FluentShiftActions.tsx
import { jsx as jsx4, jsxs } from "react/jsx-runtime";
import { Button as Button2 } from "@fluentui/react-components";
var FluentShiftActions = function FluentShiftActions2(_ref) {
  var shiftUp = _ref.shiftUp, shiftDown = _ref.shiftDown, shiftUpDisabled = _ref.shiftUpDisabled, shiftDownDisabled = _ref.shiftDownDisabled, disabled = _ref.disabled, className = _ref.className, labels = _ref.labels, titles = _ref.titles, testID = _ref.testID;
  return /* @__PURE__ */ jsxs("div", { "data-testid": testID, className, children: [/* @__PURE__ */ jsx4(Button2, { type: "button", disabled: disabled || shiftUpDisabled, onClick: shiftUp, title: titles === null || titles === void 0 ? void 0 : titles.shiftUp, children: labels === null || labels === void 0 ? void 0 : labels.shiftUp }), /* @__PURE__ */ jsx4(Button2, { type: "button", disabled: disabled || shiftDownDisabled, onClick: shiftDown, title: titles === null || titles === void 0 ? void 0 : titles.shiftDown, children: labels === null || labels === void 0 ? void 0 : labels.shiftDown })] });
};

// ../../utils/react-compiler/react-compiler-runtime.ts
import * as React from "react";
var $empty = Symbol["for"]("react.memo_cache_sentinel");
function c(size) {
  return React.useMemo(
    function() {
      var $ = new Array(size);
      for (var ii = 0; ii < size; ii++) {
        $[ii] = $empty;
      }
      $[$empty] = true;
      return $;
    },
    // oxlint-disable-next-line exhaustive-deps
    []
  );
}

// src/FluentValueEditor.tsx
import { jsx as jsx5, jsxs as jsxs2 } from "react/jsx-runtime";
import { Checkbox, Input, Radio, RadioGroup, Switch as Switch2, Textarea } from "@fluentui/react-components";
import { useValueEditor, ValueEditor } from "react-querybuilder";
function _typeof4(o) {
  "@babel/helpers - typeof";
  return _typeof4 = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function(o2) {
    return typeof o2;
  } : function(o2) {
    return o2 && "function" == typeof Symbol && o2.constructor === Symbol && o2 !== Symbol.prototype ? "symbol" : typeof o2;
  }, _typeof4(o);
}
function ownKeys4(e, r) {
  var t = Object.keys(e);
  if (Object.getOwnPropertySymbols) {
    var o = Object.getOwnPropertySymbols(e);
    r && (o = o.filter(function(r2) {
      return Object.getOwnPropertyDescriptor(e, r2).enumerable;
    })), t.push.apply(t, o);
  }
  return t;
}
function _objectSpread4(e) {
  for (var r = 1; r < arguments.length; r++) {
    var t = null != arguments[r] ? arguments[r] : {};
    r % 2 ? ownKeys4(Object(t), true).forEach(function(r2) {
      _defineProperty4(e, r2, t[r2]);
    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys4(Object(t)).forEach(function(r2) {
      Object.defineProperty(e, r2, Object.getOwnPropertyDescriptor(t, r2));
    });
  }
  return e;
}
function _defineProperty4(e, r, t) {
  return (r = _toPropertyKey4(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: true, configurable: true, writable: true }) : e[r] = t, e;
}
function _toPropertyKey4(t) {
  var i = _toPrimitive4(t, "string");
  return "symbol" == _typeof4(i) ? i : i + "";
}
function _toPrimitive4(t, r) {
  if ("object" != _typeof4(t) || !t) return t;
  var e = t[Symbol.toPrimitive];
  if (void 0 !== e) {
    var i = e.call(t, r || "default");
    if ("object" != _typeof4(i)) return i;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return ("string" === r ? String : Number)(t);
}
var FluentValueEditor = function FluentValueEditor2(allProps) {
  var _fieldData$placeholde;
  var $ = c(80);
  var fieldData = allProps.fieldData, operator = allProps.operator, value = allProps.value, handleOnChange = allProps.handleOnChange, title = allProps.title, className = allProps.className, type = allProps.type, inputType = allProps.inputType, t0 = allProps.values, separator = allProps.separator, disabled = allProps.disabled, testID = allProps.testID, extraProps = allProps.extraProps;
  var t1;
  if ($[0] !== t0) {
    t1 = t0 === void 0 ? [] : t0;
    $[0] = t0;
    $[1] = t1;
  } else {
    t1 = $[1];
  }
  var values = t1;
  var _useValueEditor = useValueEditor(allProps), valueAsArray = _useValueEditor.valueAsArray, multiValueHandler = _useValueEditor.multiValueHandler, bigIntValueHandler = _useValueEditor.bigIntValueHandler, valueListItemClassName = _useValueEditor.valueListItemClassName, inputTypeCoerced = _useValueEditor.inputTypeCoerced;
  if (operator === "null" || operator === "notNull") {
    return null;
  }
  var placeHolderText = (_fieldData$placeholde = fieldData === null || fieldData === void 0 ? void 0 : fieldData.placeholder) !== null && _fieldData$placeholde !== void 0 ? _fieldData$placeholde : "";
  if ((operator === "between" || operator === "notBetween") && (type === "select" || type === "text")) {
    if (type === "text") {
      var _t;
      if ($[2] !== className || $[3] !== disabled || $[4] !== extraProps || $[5] !== inputTypeCoerced || $[6] !== multiValueHandler || $[7] !== placeHolderText || $[8] !== separator || $[9] !== testID || $[10] !== title || $[11] !== valueAsArray || $[12] !== valueListItemClassName) {
        var editors = ["from", "to"].map(function(key, i) {
          var _valueAsArray$i;
          return jsx5(Input, _objectSpread4({ type: inputTypeCoerced, placeholder: placeHolderText, value: (_valueAsArray$i = valueAsArray[i]) !== null && _valueAsArray$i !== void 0 ? _valueAsArray$i : "", className: "".concat(valueListItemClassName, " input"), disabled, onChange: function onChange(e) {
            return multiValueHandler(e.target.value, i);
          } }, extraProps), key);
        });
        _t = jsxs2("span", { "data-testid": testID, className, title, children: [editors[0], separator, editors[1]] });
        $[2] = className;
        $[3] = disabled;
        $[4] = extraProps;
        $[5] = inputTypeCoerced;
        $[6] = multiValueHandler;
        $[7] = placeHolderText;
        $[8] = separator;
        $[9] = testID;
        $[10] = title;
        $[11] = valueAsArray;
        $[12] = valueListItemClassName;
        $[13] = _t;
      } else {
        _t = $[13];
      }
      return _t;
    }
    var _t2;
    if ($[14] !== allProps) {
      _t2 = jsx5(ValueEditor, _objectSpread4(_objectSpread4({}, allProps), {}, { skipHook: true }));
      $[14] = allProps;
      $[15] = _t2;
    } else {
      _t2 = $[15];
    }
    return _t2;
  }
  switch (type) {
    case "select": {
    }
    case "multiselect": {
      var _t3;
      if ($[16] !== allProps) {
        _t3 = jsx5(ValueEditor, _objectSpread4(_objectSpread4({}, allProps), {}, { skipHook: true }));
        $[16] = allProps;
        $[17] = _t3;
      } else {
        _t3 = $[17];
      }
      return _t3;
    }
    case "textarea": {
      var _t4;
      if ($[18] !== handleOnChange) {
        _t4 = function _t42(e_2) {
          return handleOnChange(e_2.target.value);
        };
        $[18] = handleOnChange;
        $[19] = _t4;
      } else {
        _t4 = $[19];
      }
      var _t5;
      if ($[20] !== className || $[21] !== disabled || $[22] !== extraProps || $[23] !== placeHolderText || $[24] !== _t4 || $[25] !== title || $[26] !== value) {
        _t5 = jsx5(Textarea, _objectSpread4({ className, value, title, placeholder: placeHolderText, disabled, onChange: _t4 }, extraProps));
        $[20] = className;
        $[21] = disabled;
        $[22] = extraProps;
        $[23] = placeHolderText;
        $[24] = _t4;
        $[25] = title;
        $[26] = value;
        $[27] = _t5;
      } else {
        _t5 = $[27];
      }
      return _t5;
    }
    case "switch": {
      var _t6;
      if ($[28] !== handleOnChange) {
        _t6 = function _t62(e_1) {
          return handleOnChange(e_1.target.checked);
        };
        $[28] = handleOnChange;
        $[29] = _t6;
      } else {
        _t6 = $[29];
      }
      var _t7;
      if ($[30] !== className || $[31] !== disabled || $[32] !== extraProps || $[33] !== _t6 || $[34] !== title || $[35] !== value) {
        _t7 = jsx5(Switch2, _objectSpread4({ className, title, checked: value, disabled, onChange: _t6 }, extraProps));
        $[30] = className;
        $[31] = disabled;
        $[32] = extraProps;
        $[33] = _t6;
        $[34] = title;
        $[35] = value;
        $[36] = _t7;
      } else {
        _t7 = $[36];
      }
      return _t7;
    }
    case "checkbox": {
      var _t8;
      if ($[37] !== handleOnChange) {
        _t8 = function _t82(e_0) {
          return handleOnChange(e_0.target.checked);
        };
        $[37] = handleOnChange;
        $[38] = _t8;
      } else {
        _t8 = $[38];
      }
      var _t9;
      if ($[39] !== className || $[40] !== disabled || $[41] !== extraProps || $[42] !== _t8 || $[43] !== title || $[44] !== value) {
        _t9 = jsx5(Checkbox, _objectSpread4({ className, title, checked: value, disabled, onChange: _t8 }, extraProps));
        $[39] = className;
        $[40] = disabled;
        $[41] = extraProps;
        $[42] = _t8;
        $[43] = title;
        $[44] = value;
        $[45] = _t9;
      } else {
        _t9 = $[45];
      }
      return _t9;
    }
    case "radio": {
      var _t0;
      if ($[46] !== handleOnChange) {
        _t0 = function _t02(_e, data) {
          return handleOnChange(data.value);
        };
        $[46] = handleOnChange;
        $[47] = _t0;
      } else {
        _t0 = $[47];
      }
      var _t1;
      if ($[48] !== className || $[49] !== disabled || $[50] !== extraProps || $[51] !== _t0 || $[52] !== title || $[53] !== value || $[54] !== values) {
        _t1 = jsx5(RadioGroup, _objectSpread4(_objectSpread4({ className, title, value, onChange: _t0, disabled }, extraProps), {}, { children: values.map(_temp) }));
        $[48] = className;
        $[49] = disabled;
        $[50] = extraProps;
        $[51] = _t0;
        $[52] = title;
        $[53] = value;
        $[54] = values;
        $[55] = _t1;
      } else {
        _t1 = $[55];
      }
      return _t1;
    }
  }
  if (inputType === "bigint") {
    var _t10 = "".concat(value);
    var _t11;
    if ($[56] !== bigIntValueHandler) {
      _t11 = function _t112(e_3) {
        return bigIntValueHandler(e_3.target.value);
      };
      $[56] = bigIntValueHandler;
      $[57] = _t11;
    } else {
      _t11 = $[57];
    }
    var t4;
    if ($[58] !== className || $[59] !== disabled || $[60] !== extraProps || $[61] !== inputTypeCoerced || $[62] !== placeHolderText || $[63] !== _t10 || $[64] !== _t11 || $[65] !== testID || $[66] !== title) {
      t4 = jsx5(Input, _objectSpread4({ "data-testid": testID, type: inputTypeCoerced, placeholder: placeHolderText, value: _t10, title, className, disabled, onChange: _t11 }, extraProps));
      $[58] = className;
      $[59] = disabled;
      $[60] = extraProps;
      $[61] = inputTypeCoerced;
      $[62] = placeHolderText;
      $[63] = _t10;
      $[64] = _t11;
      $[65] = testID;
      $[66] = title;
      $[67] = t4;
    } else {
      t4 = $[67];
    }
    return t4;
  }
  var t2;
  if ($[68] !== handleOnChange) {
    t2 = function t22(e_4) {
      return handleOnChange(e_4.target.value);
    };
    $[68] = handleOnChange;
    $[69] = t2;
  } else {
    t2 = $[69];
  }
  var t3;
  if ($[70] !== className || $[71] !== disabled || $[72] !== extraProps || $[73] !== inputTypeCoerced || $[74] !== placeHolderText || $[75] !== t2 || $[76] !== testID || $[77] !== title || $[78] !== value) {
    t3 = jsx5(Input, _objectSpread4({ "data-testid": testID, title, className, placeholder: placeHolderText, type: inputTypeCoerced, disabled, value, onChange: t2 }, extraProps));
    $[70] = className;
    $[71] = disabled;
    $[72] = extraProps;
    $[73] = inputTypeCoerced;
    $[74] = placeHolderText;
    $[75] = t2;
    $[76] = testID;
    $[77] = title;
    $[78] = value;
    $[79] = t3;
  } else {
    t3 = $[79];
  }
  return t3;
};
function _temp(v) {
  return jsx5(Radio, { value: v.name, label: v.label }, v.name);
}

// src/FluentValueSelector.tsx
import { jsx as jsx7 } from "react/jsx-runtime";
import { Dropdown, Select } from "@fluentui/react-components";
import { toArray, toOptions, useValueSelector } from "react-querybuilder";

// src/utils.tsx
import { jsx as jsx6 } from "react/jsx-runtime";
import { Option, OptionGroup } from "@fluentui/react-components";
import { isOptionGroupArray } from "react-querybuilder";
var toDropdownOptions = function toDropdownOptions2(list) {
  return isOptionGroupArray(list) ? list.map(function(og) {
    return /* @__PURE__ */ jsx6(OptionGroup, { label: og.label, children: og.options.map(function(opt) {
      return /* @__PURE__ */ jsx6(Option, { value: opt.name, disabled: !!opt.disabled, children: opt.label }, opt.name);
    }) }, og.label);
  }) : Array.isArray(list) ? list.map(function(opt) {
    return /* @__PURE__ */ jsx6(Option, { value: opt.name, disabled: !!opt.disabled, children: opt.label }, opt.name);
  }) : (
    // istanbul ignore next
    null
  );
};

// src/FluentValueSelector.tsx
function _typeof5(o) {
  "@babel/helpers - typeof";
  return _typeof5 = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function(o2) {
    return typeof o2;
  } : function(o2) {
    return o2 && "function" == typeof Symbol && o2.constructor === Symbol && o2 !== Symbol.prototype ? "symbol" : typeof o2;
  }, _typeof5(o);
}
var _excluded4 = ["className", "handleOnChange", "options", "value", "title", "disabled", "multiple", "listsAsArrays", "testID", "placeholder", "fieldData", "path", "level", "context", "validation", "schema", "rule", "rules"];
function ownKeys5(e, r) {
  var t = Object.keys(e);
  if (Object.getOwnPropertySymbols) {
    var o = Object.getOwnPropertySymbols(e);
    r && (o = o.filter(function(r2) {
      return Object.getOwnPropertyDescriptor(e, r2).enumerable;
    })), t.push.apply(t, o);
  }
  return t;
}
function _objectSpread5(e) {
  for (var r = 1; r < arguments.length; r++) {
    var t = null != arguments[r] ? arguments[r] : {};
    r % 2 ? ownKeys5(Object(t), true).forEach(function(r2) {
      _defineProperty5(e, r2, t[r2]);
    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys5(Object(t)).forEach(function(r2) {
      Object.defineProperty(e, r2, Object.getOwnPropertyDescriptor(t, r2));
    });
  }
  return e;
}
function _defineProperty5(e, r, t) {
  return (r = _toPropertyKey5(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: true, configurable: true, writable: true }) : e[r] = t, e;
}
function _toPropertyKey5(t) {
  var i = _toPrimitive5(t, "string");
  return "symbol" == _typeof5(i) ? i : i + "";
}
function _toPrimitive5(t, r) {
  if ("object" != _typeof5(t) || !t) return t;
  var e = t[Symbol.toPrimitive];
  if (void 0 !== e) {
    var i = e.call(t, r || "default");
    if ("object" != _typeof5(i)) return i;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return ("string" === r ? String : Number)(t);
}
function _objectWithoutProperties4(e, t) {
  if (null == e) return {};
  var o, r, i = _objectWithoutPropertiesLoose4(e, t);
  if (Object.getOwnPropertySymbols) {
    var n = Object.getOwnPropertySymbols(e);
    for (r = 0; r < n.length; r++) o = n[r], -1 === t.indexOf(o) && {}.propertyIsEnumerable.call(e, o) && (i[o] = e[o]);
  }
  return i;
}
function _objectWithoutPropertiesLoose4(r, e) {
  if (null == r) return {};
  var t = {};
  for (var n in r) if ({}.hasOwnProperty.call(r, n)) {
    if (-1 !== e.indexOf(n)) continue;
    t[n] = r[n];
  }
  return t;
}
var FluentValueSelector = function FluentValueSelector2(t0) {
  var $ = c(28);
  var className;
  var disabled;
  var handleOnChange;
  var listsAsArrays;
  var multiple;
  var options;
  var otherProps;
  var placeholder;
  var testID;
  var title;
  var value;
  if ($[0] !== t0) {
    var _t = t0.className, _t2 = t0.handleOnChange, t3 = t0.options, t4 = t0.value, t5 = t0.title, t6 = t0.disabled, t7 = t0.multiple, t8 = t0.listsAsArrays, t9 = t0.testID, t10 = t0.placeholder, _fieldData = t0.fieldData, _path = t0.path, _level = t0.level, _context = t0.context, _validation = t0.validation, _schema = t0.schema, _rule = t0.rule, _rules = t0.rules, t11 = _objectWithoutProperties4(t0, _excluded4);
    className = _t;
    handleOnChange = _t2;
    options = t3;
    value = t4;
    title = t5;
    disabled = t6;
    multiple = t7;
    listsAsArrays = t8;
    testID = t9;
    placeholder = t10;
    otherProps = t11;
    $[0] = t0;
    $[1] = className;
    $[2] = disabled;
    $[3] = handleOnChange;
    $[4] = listsAsArrays;
    $[5] = multiple;
    $[6] = options;
    $[7] = otherProps;
    $[8] = placeholder;
    $[9] = testID;
    $[10] = title;
    $[11] = value;
  } else {
    className = $[1];
    disabled = $[2];
    handleOnChange = $[3];
    listsAsArrays = $[4];
    multiple = $[5];
    options = $[6];
    otherProps = $[7];
    placeholder = $[8];
    testID = $[9];
    title = $[10];
    value = $[11];
  }
  var t1;
  if ($[12] !== handleOnChange || $[13] !== listsAsArrays || $[14] !== multiple || $[15] !== value) {
    t1 = { handleOnChange, listsAsArrays, multiple, value };
    $[12] = handleOnChange;
    $[13] = listsAsArrays;
    $[14] = multiple;
    $[15] = value;
    $[16] = t1;
  } else {
    t1 = $[16];
  }
  var _useValueSelector = useValueSelector(t1), _onChange = _useValueSelector.onChange, val = _useValueSelector.val;
  var t2;
  if ($[17] !== className || $[18] !== disabled || $[19] !== multiple || $[20] !== _onChange || $[21] !== options || $[22] !== otherProps || $[23] !== placeholder || $[24] !== testID || $[25] !== title || $[26] !== val) {
    t2 = multiple ? jsx7(Dropdown, { "data-testid": testID, title, className, disabled, multiselect: true, value: toArray(val).join(", "), placeholder, selectedOptions: toArray(val), onOptionSelect: function onOptionSelect(_e, data) {
      return _onChange(data.selectedOptions);
    }, children: toDropdownOptions(options) }) : jsx7(Select, _objectSpread5(_objectSpread5({}, otherProps), {}, { "data-testid": testID, title, className, value: val, disabled, multiple: !!multiple, onChange: function onChange(_e_0, data_0) {
      return _onChange(data_0.value);
    }, children: toOptions(options) }));
    $[17] = className;
    $[18] = disabled;
    $[19] = multiple;
    $[20] = _onChange;
    $[21] = options;
    $[22] = otherProps;
    $[23] = placeholder;
    $[24] = testID;
    $[25] = title;
    $[26] = val;
    $[27] = t2;
  } else {
    t2 = $[27];
  }
  return t2;
};

// src/index.tsx
var fluentControlElements = { actionElement: FluentActionElement, dragHandle: FluentDragHandle, notToggle: FluentNotToggle, shiftActions: FluentShiftActions, valueEditor: FluentValueEditor, valueSelector: FluentValueSelector };
var fluentTranslations = { removeGroup: { label: /* @__PURE__ */ jsx8(CancelIcon, {}) }, removeRule: { label: /* @__PURE__ */ jsx8(CancelIcon, {}) }, cloneRule: { label: /* @__PURE__ */ jsx8(DuplicateRowIcon, {}) }, cloneRuleGroup: { label: /* @__PURE__ */ jsx8(DuplicateRowIcon, {}) }, dragHandle: { label: /* @__PURE__ */ jsx8(GripperDotsVerticalIcon, {}) }, lockGroup: { label: /* @__PURE__ */ jsx8(UnlockIcon, {}) }, lockRule: { label: /* @__PURE__ */ jsx8(UnlockIcon, {}) }, lockGroupDisabled: { label: /* @__PURE__ */ jsx8(LockIcon, {}) }, lockRuleDisabled: { label: /* @__PURE__ */ jsx8(LockIcon, {}) }, shiftActionDown: { label: /* @__PURE__ */ jsx8(ChevronDownIcon, {}) }, shiftActionUp: { label: /* @__PURE__ */ jsx8(ChevronUpIcon, {}) } };
var QueryBuilderFluent = getCompatContextProvider({ controlElements: fluentControlElements, translations: fluentTranslations });
export {
  FluentActionElement,
  FluentDragHandle,
  FluentNotToggle,
  FluentShiftActions,
  FluentValueEditor,
  FluentValueSelector,
  QueryBuilderFluent,
  fluentControlElements,
  fluentTranslations
};
//# sourceMappingURL=react-querybuilder_fluent.mjs.map